package com.company.fetchissueproject.core;

import io.jmix.core.metamodel.datatype.impl.EnumClass;

import javax.annotation.Nullable;


public enum LifeCycleEventType implements EnumClass<Integer> {

    LCE_CREATE(1),
    LCE_RELEASE(2),
    LCE_CHECK(3),
    LCE_APPROVE(4),
    LCE_REJECT(5),
    LCE_BOOK(6),
    LCE_EXECUTE(7),
    LCE_SUBMIT(8),
    LCE_CANCEL(9),
    LCE_SUPERSEDED(10),
    LCE_MODIFY(11);

    private Integer id;

    LifeCycleEventType(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    @Nullable
    public static LifeCycleEventType fromId(Integer id) {
        for (LifeCycleEventType at : LifeCycleEventType.values()) {
            if (at.getId().equals(id)) {
                return at;
            }
        }
        return null;
    }
}