package com.company.fetchissueproject.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.CaseConversion;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "FIP_DOC_VERSION", indexes = {
        @Index(name = "IDX_FIP_DOC_VERSION_DOV_DOC", columnList = "DOV_DOC_ID")
})
@Entity(name = "FIP_DocVersion")
public class DocVersion {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CaseConversion
    @Column(name = "DOV_ID", nullable = false, length = 3)
    @NotNull
    @InstanceName
    private String dovId;

    @Column(name = "DOV_DESCR")
    @Lob
    private String dovDescr;

    @Column(name = "DOV_CREATION_DATE", nullable = false)
    @NotNull
    private LocalDateTime dovCreationDate;

    @Column(name = "DOV_LAST_CHANGE_DATE", nullable = false)
    @NotNull
    private LocalDateTime dovLastChangeDate;

    @Composition
    @OrderBy("lceCreationDate")
    @OneToMany(mappedBy = "lceDov", cascade = CascadeType.ALL)
    private List<LifeCycleEvent> dovLces = new ArrayList<>();

    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "DOV_DOC_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Document dovDoc;

    public List<LifeCycleEvent> getDovLces() {
        return dovLces;
    }

    public void setDovLces(List<LifeCycleEvent> dovLces) {
        this.dovLces = dovLces;
    }

    public Document getDovDoc() {
        return dovDoc;
    }

    public void setDovDoc(Document dovDoc) {
        this.dovDoc = dovDoc;
    }

    public LocalDateTime getDovLastChangeDate() {
        return dovLastChangeDate;
    }

    public void setDovLastChangeDate(LocalDateTime dovLastChangeDate) {
        this.dovLastChangeDate = dovLastChangeDate;
    }

    public LocalDateTime getDovCreationDate() {
        return dovCreationDate;
    }

    public void setDovCreationDate(LocalDateTime dovCreationDate) {
        this.dovCreationDate = dovCreationDate;
    }

    public String getDovDescr() {
        return dovDescr;
    }

    public void setDovDescr(String dovDescr) {
        this.dovDescr = dovDescr;
    }

    public String getDovId() {
        return dovId;
    }

    public void setDovId(String dovId) {
        this.dovId = dovId;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}