package com.company.fetchissueproject.entity;

import io.jmix.core.entity.annotation.CaseConversion;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "FIP_DOCUMENT")
@Entity(name = "FIP_Document")
public class Document {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CaseConversion
    @Column(name = "DOC_CODE", nullable = false, length = 50)
    @NotNull
    @InstanceName
    private String docCode;

    @Column(name = "DOC_TITLE", nullable = false)
    @Lob
    @NotNull
    private String docTitle;

    @Composition
    @OrderBy("dovId")
    @OneToMany(mappedBy = "dovDoc", cascade = CascadeType.ALL)
    private List<DocVersion> docDovs = new ArrayList<>();

    public List<DocVersion> getDocDovs() {
        return docDovs;
    }

    public void setDocDovs(List<DocVersion> docDovs) {
        this.docDovs = docDovs;
    }

    public String getDocTitle() {
        return docTitle;
    }

    public void setDocTitle(String docTitle) {
        this.docTitle = docTitle;
    }

    public String getDocCode() {
        return docCode;
    }

    public void setDocCode(String docCode) {
        this.docCode = docCode;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}