package com.company.fetchissueproject.entity;

import com.company.fetchissueproject.core.LifeCycleEventType;
import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;
import java.util.UUID;

@JmixEntity
@Table(name = "FIP_LIFE_CYCLE_EVENT", indexes = {
        @Index(name = "IDX_FIP_LIFE_CYCLE_EVENT_LCE_DOV", columnList = "LCE_DOV_ID")
})
@Entity(name = "FIP_LifeCycleEvent")
public class LifeCycleEvent {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @Column(name = "LCE_TYPE", nullable = false)
    @NotNull
    private Integer lceType;

    @Column(name = "LCE_CREATION_DATE", nullable = false)
    @NotNull
    private LocalDateTime lceCreationDate;

    @Column(name = "LCE_NOTES", length = 250)
    private String lceNotes;

    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "LCE_DOV_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private DocVersion lceDov;

    public DocVersion getLceDov() {
        return lceDov;
    }

    public void setLceDov(DocVersion lceDov) {
        this.lceDov = lceDov;
    }

    public String getLceNotes() {
        return lceNotes;
    }

    public void setLceNotes(String lceNotes) {
        this.lceNotes = lceNotes;
    }

    public LocalDateTime getLceCreationDate() {
        return lceCreationDate;
    }

    public void setLceCreationDate(LocalDateTime lceCreationDate) {
        this.lceCreationDate = lceCreationDate;
    }

    public LifeCycleEventType getLceType() {
        return lceType == null ? null : LifeCycleEventType.fromId(lceType);
    }

    public void setLceType(LifeCycleEventType lceType) {
        this.lceType = lceType == null ? null : lceType.getId();
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}