package com.company.fetchissueproject.screen.document;

import com.company.fetchissueproject.core.LifeCycleEventType;
import com.company.fetchissueproject.entity.DocVersion;
import com.company.fetchissueproject.entity.LifeCycleEvent;
import io.jmix.ui.model.DataContext;
import io.jmix.ui.screen.*;
import com.company.fetchissueproject.entity.Document;
import org.apache.tomcat.jni.Time;
import org.springframework.beans.factory.annotation.Autowired;

import java.time.LocalDateTime;

@UiController("FIP_Document.edit")
@UiDescriptor("document-edit.xml")
@EditedEntityContainer("documentDc")
public class DocumentEdit extends StandardEditor<Document> {
    @Autowired
    DataContext dataContext;
    @Subscribe
    public void onBeforeCommitChanges(final BeforeCommitChangesEvent event) {
        Document document = this.getEditedEntity();
        DocVersion docVersion = dataContext.create(DocVersion.class);
        document.getDocDovs().add(docVersion);
        docVersion.setDovDoc(document);
        docVersion.setDovId("A");
        docVersion.setDovDescr("This is version A");
        docVersion.setDovCreationDate(LocalDateTime.now());
        docVersion.setDovLastChangeDate(LocalDateTime.now());
        LifeCycleEvent lifeCycleEvent = dataContext.create(LifeCycleEvent.class);
        lifeCycleEvent.setLceCreationDate(LocalDateTime.now());
        lifeCycleEvent.setLceNotes("Notes content");
        lifeCycleEvent.setLceType(LifeCycleEventType.LCE_CREATE);
        lifeCycleEvent.setLceDov(docVersion);
        docVersion.getDovLces().add(lifeCycleEvent);
    }

}
