package com.company.fetchissueproject.screen.docversion;

import com.company.fetchissueproject.entity.LifeCycleEvent;
import io.jmix.core.DataManager;
import io.jmix.core.LoadContext;
import io.jmix.ui.component.Table;
import io.jmix.ui.screen.*;
import com.company.fetchissueproject.entity.DocVersion;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

@UiController("FIP_DocVersion.browse")
@UiDescriptor("doc-version-browse.xml")
@LookupComponent("docVersionsTable")
public class DocVersionBrowse extends StandardLookup<DocVersion> {
    @Autowired
    protected DataManager dataManager;
    @Autowired
    private Table<DocVersion> docVersionsTable;

    @Install(to = "docVersionsDl", target = Target.DATA_LOADER)
    private List<DocVersion> docVersionsDlLoadDelegate(LoadContext<DocVersion> loadContext) {
//        return dataManager.load(DocVersion.class)
//                .query("select dov from FIP_DocVersion dov")
//                .list();
        String queryStr = "select dov from FIP_Document doc " +
                " join doc.docDovs dov ";
        String orderByStr = " order by doc.docCode, dov.dovId ";
        String fullQueryStr;
        // Query all entries
        fullQueryStr = queryStr + orderByStr;
        return dataManager.load(DocVersion.class)
                .query(fullQueryStr)
                .list();
    }
    @Subscribe("docVersionsTable")
    public void onDocVersionsTableSelection(Table.SelectionEvent<DocVersion> event) {
        // Enable appropriate functionalities when an item is selected
        DocVersion docVersion = docVersionsTable.getSingleSelected();
        if (docVersion != null) {
            List<LifeCycleEvent> lces = docVersion.getDovLces();
        }
    }

}